Option Objects

Class MahyongEvent

	Private Ronde as Byte
	Private RondeWind as String 
	Private RodeLatPos as Byte
	Private playerObject(1 to 4) As Player
	Private Mahyong_owner as Byte
	
	Public Sub _Create()
		Ronde = 1
		RondeWind = "Oost"
	End Sub

	Public Function GetRonde() as Byte
		GetRonde = Ronde
	End Function 
	
	Public Function GetRondeWind() as String
		GetRondeWind = RondeWind
	End Function 
	
	Public Function GetRodeLatPos() as Byte
		GetRodeLatPos = RodeLatPos
	End Function 

	Public Sub Calculate()
		Dim i As Integer, j As Integer
		For i = 1 To 4 
			If PlayerObject(i).isMahYong Then	
				If PlayerObject(i).isRed Then				
					Call PlayerObject(i).setPoints(playerObject(i).getPoints + 6 * playerObject(i).getNewPoints)			
				Else		
					Call PlayerObject(i).setPoints(playerObject(i).getPoints + 4 * playerObject(i).getNewPoints)
				End If		
			End If
			For j  = 1 to 4	
				If i <> j Then
					If NOT PlayerObject(i).isMahYong Then
						If PlayerObject(i).isRed or PlayerObject(j).isRed Then				
							If PlayerObject(j).isMahYong Then					
								Call PlayerObject(i).setPoints(playerObject(i).getPoints - 2 * playerObject(j).getNewPoints)						
							Else 					
								Call PlayerObject(i).setPoints(playerObject(i).getPoints + 2 * (playerObject(i).getNewPoints - playerObject(j).getNewPoints))				
							End If					
						Else				
							If PlayerObject(j).isMahYong Then					
								Call PlayerObject(i).setPoints(playerObject(i).getPoints - playerObject(j).getNewPoints)						
							Else 					
								Call PlayerObject(i).setPoints(playerObject(i).getPoints + (playerObject(i).getNewPoints - playerObject(j).getNewPoints))						
							End If				
						End If				
					End If				
				End if		
			Next j
		Next i
		ronde = ronde + 1
		If RodeLatPos <> Mahyong_owner Then
			Call UpdateRodeLatUser
		End If
		Call SetRondeWind()
	End Sub
	
	Private Sub SetRondeWind()
		Dim modnum as Byte 
		modnum = ((ronde - 1) \ 4 ) Mod 4 + 1 
		Select Case modnum
			Case 1
				rondeWind = "Oost"
			Case 2
				rondeWind = "Zuid"
			Case 3
				rondeWind = "West"
			Case 4
				rondeWind = "Noord"
		End Select
	End Sub
	
	Public Sub ImportNewPoints(ByRef points() as Long)
		Dim userNumber as Byte
		For userNumber = 1 to 4
			Call PlayerObject(userNumber).setNewPoints(Points(userNumber))  
		Next userNumber
	End Sub
	
	Public Sub GetNewTotals(ByRef points() as Long)
		Dim userNumber as Byte
		For userNumber = 1 to 4
			Points(userNumber) = PlayerObject(userNumber).getPoints  
		Next userNumber
	End Sub

	Public Sub InitRodeLatUser(ByVal playerNr as Byte)
		Dim i as Byte
		RodeLatPos = playerNr
		For i = 1 to 4 
			If i = playerNr Then
				Call PlayerObject(i).setRed(True)
			Else
				Call PlayerObject(i).setRed(False)
			End if
		Next i
	End Sub
	
	Private Sub UpdateRodeLatUser()
		Select Case RodeLatPos
		Case 1
			Call InitRodeLatUser(2)
		Case 2
			Call InitRodeLatUser(3)
		Case 3
			Call InitRodeLatUser(4)
		Case 4
			Call InitRodeLatUser(1)
		End Select
	End Sub

	Public Sub SetMahyongUser(ByVal playerNr as Byte)
		Dim i as Byte
		Mahyong_owner = playerNr
		For i = 1 to 4 
			If i = playerNr Then
				Call PlayerObject(i).SetMahyong(True)
			Else
				Call PlayerObject(i).setMahyong(False)
			End if
		Next i
	End Sub

End Class